﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.ParallelArrays;
using PA = Microsoft.ParallelArrays.ParallelArrays;
using BPA = Microsoft.ParallelArrays.BoolParallelArray;
using DPA = Microsoft.ParallelArrays.DoubleParallelArray;
using FPA = Microsoft.ParallelArrays.FloatParallelArray;
using IPA = Microsoft.ParallelArrays.IntParallelArray;
using F4PA = Microsoft.ParallelArrays.Float4ParallelArray;
using System.Windows.Media;

namespace ImageLab.Filter
{
    public static class Analysis
    {
        public static F4PA Variance(F4PA input, params object[] parameters)
        {
            var radius = (int)parameters[0];
            var n_samples = (2 * radius + 1) * (2 * radius + 1);

            var mean = MeanFilter.Mean(input, radius);// u = E[X]

            var var_acc = new Float4ParallelArray(new Float4(0f), input.Shape);

            for (int i = -radius; i <= radius; i++)
            {
                for (int j = -radius; j <= radius; j++)
                {
                    var dvar = PA.Shift(input, new int[] { i, j }) - mean;
                    dvar = dvar * dvar;
                    var_acc += dvar;
                }
            }

            var normalizingFact = n_samples == 1 ? 1 : n_samples - 1;
            return var_acc / new Float4(normalizingFact);
        }

        public static F4PA Null(F4PA input, params object[] parameters)
        {
            return input;
        }
        public const int HistogramBins = 100;
        public static Float4[] Histogram(F4PA input, params object[] parameters)
        {
            input = new Float4(HistogramBins - 1) * input;
            var image = FilterCore.DX9.ToArray2D(input);
            var histogram = new Float4[HistogramBins];

            for (int x = 0; x < image.GetLength(0); x++)
            {
                for (int y = 0; y < image.GetLength(1); y++)
                {
                    histogram[(int)image[x, y].f1].f1++;
                    histogram[(int)image[x, y].f2].f2++;
                    histogram[(int)image[x, y].f3].f3++;
                    histogram[(int)image[x, y].f4].f4++;
                }

            }
            return histogram;
        }
    }
}
