﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ImageLab.Filter
{
    public class ByteImage
    {

        public byte[,] Image { get; set; }
        public FilterWindow Window { get; set; }
        public int Width
        {
            get
            {
                return Image.GetLength(0);
            }
        }
        public int Height
        {
            get
            {
                return Image.GetLength(1);
            }
        }
        public ByteImage(byte[,] image)
        {
            Image = image;
            Window = new FilterWindow(image.GetLength(0), image.GetLength(1), 1);
        }
        public bool Contains(Coordinate input)
        {
            var max = new Coordinate(Width, Height);
            return Coordinate.Contains(input, Coordinate.Zero, max);
        }

        public byte this[int x, int y]
        {
            get { return this[new Coordinate(x, y)]; }
            set { Image[x, y] = value; }
        }
        public byte this[Coordinate position]
        {
            get
            {
                return Image[position.X, position.Y];
            }
            set { Image[position.X, position.Y] = value; }
        }
    }
}
