﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ImageLab.Filter
{
    public class HistogramArray
    {
        private Histogram[] bank;
        private int radius;
        public int Position { get; set; }

        public Histogram OutsideTop
        {
            get
            {
                var pos = Position - radius - 1;
                if (pos >= 0) return this[pos];
                else return null;
            }
        }
        public Histogram WindowTop
        {
            get
            {
                var pos = Position - radius;
                if (pos >= 0) return this[pos];
                else return null;
            }
        }
        public Histogram Center { get { return this[Position]; } }
        public Histogram WindowBottom
        {
            get
            {
                var pos = Position + radius;
                if (pos < bank.Length) return this[pos];
                else return null;
            }
        }
        public Histogram OutsideBottom
        {
            get
            {
                var pos = Position + radius + 1;
                if (pos < bank.Length) return this[pos];
                else return null;
            }
        }

        public Histogram GetRelative(int input)
        {
            var pos = Position + input;
            if (pos >= 0 & pos < bank.Length) return this[pos];
            else return null;
        }

        public HistogramArray(int banks, int radius)
        {
            this.bank = new Histogram[banks];
            for (int i = 0; i < bank.Length; i++)
            {
                this.bank[i] = new Histogram();
            }
            this.radius = radius;
        }


        public Histogram this[int index]
        {
            get { return bank[index]; }
            set { bank[index] = value; }
        }
    }
}
