﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.ParallelArrays;
using PA = Microsoft.ParallelArrays.ParallelArrays;
using BPA = Microsoft.ParallelArrays.BoolParallelArray;
using DPA = Microsoft.ParallelArrays.DoubleParallelArray;
using FPA = Microsoft.ParallelArrays.FloatParallelArray;
using IPA = Microsoft.ParallelArrays.IntParallelArray;
using F4PA = Microsoft.ParallelArrays.Float4ParallelArray;
using System.Windows.Media;

namespace ImageLab.Filter
{
    public static class HybridMeanMedianFilter
    {
        public static F4PA HybridMeanMedian(F4PA input, params object[] parameters)
        {
            var radius = (int)parameters[0];
            var crossover = new F4PA(
                new Float4(
                    (float)parameters[1]),
                    input.Shape);

            // Calculating variance, mean and median for a given radius
            var variance = Analysis.Variance(input, radius);
            var mean = MeanFilter.Mean(input, radius);
            var median = MedianFilter.Median(input, radius);

            // if variance is above crossover, use median else use mean
            return PA.Select(variance - crossover, median, mean);
        }
        public static F4PA HybridMeanDWMedian(F4PA input, params object[] parameters)
        {
            var radius = (int)parameters[0];
            var crossover = new F4PA(
                new Float4(
                    (float)parameters[1]),
                    input.Shape);

            // Calculating variance, mean and median for a given radius
            var variance = Analysis.Variance(input, radius);
            var mean = MeanFilter.Mean(input, radius);
            var median = DistanceWeightedMedian.DWMedian(input, radius);

            // if variance is above crossover, use median else use mean
            return PA.Select(variance - crossover, median, mean);
        }
    }
}
