﻿using ImageLab.Filter;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace ImageLabTests
{


    /// <summary>
    ///This is a test class for CoordinateTest and is intended
    ///to contain all CoordinateTest Unit Tests
    ///</summary>
    [TestClass()]
    public class CoordinateTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for Coordinate Constructor
        ///</summary>
        [TestMethod()]
        public void CoordinateConstructorTest()
        {
            Coordinate target = new Coordinate();
            Assert.IsNotNull(target);
            Assert.AreEqual(target.X, 0);
            Assert.AreEqual(target.Y, 0);
        }

        /// <summary>
        ///A test for Coordinate Constructor
        ///</summary>
        [TestMethod()]
        public void CoordinateConstructorTest1()
        {
            int X = 0;
            int Y = 0;
            Coordinate target = new Coordinate(X, Y);
            Assert.AreEqual(target.X, 0);
            Assert.AreEqual(target.Y, 0);
        }

        /// <summary>
        ///A test for Clamp
        ///</summary>
        [TestMethod()]
        public void ClampTest()
        {
            Coordinate input = new Coordinate(5, 5);
            Coordinate min = new Coordinate(0, 0);
            Coordinate max = new Coordinate(5, 5);
            Coordinate expected = new Coordinate(4, 4);
            Coordinate actual;
            actual = Coordinate.Clamp(input, min, max);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for op_Addition
        ///</summary>
        [TestMethod()]
        public void op_AdditionTest()
        {
            Coordinate a = new Coordinate(5, 1);
            Coordinate b = new Coordinate(1, 5);
            Coordinate expected = new Coordinate(6, 6);
            Coordinate actual;
            actual = (a + b);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for op_Multiply
        ///</summary>
        [TestMethod()]
        public void op_MultiplyTest()
        {
            int a = 5;
            Coordinate b = new Coordinate(1, 5);
            Coordinate expected = new Coordinate(5, 25);
            Coordinate actual;
            actual = (a * b);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for op_Multiply
        ///</summary>
        [TestMethod()]
        public void op_MultiplyTest1()
        {
            Coordinate a = new Coordinate(2, 6);
            Coordinate b = new Coordinate(3, -6);
            Coordinate expected = new Coordinate(6, -36);
            Coordinate actual;
            actual = (a * b);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for op_Subtraction
        ///</summary>
        [TestMethod()]
        public void op_SubtractionTest()
        {
            Coordinate a = new Coordinate(5, 1);
            Coordinate b = new Coordinate(5, 1);
            Coordinate expected = Coordinate.Zero; 
            Coordinate actual;
            actual = (a - b);
            Assert.AreEqual(expected, actual);
        }
    }
}