﻿using ImageLab.Filter;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace ImageLabTests
{


    /// <summary>
    ///This is a test class for FilterWindowTest and is intended
    ///to contain all FilterWindowTest Unit Tests
    ///</summary>
    [TestClass()]
    public class FilterWindowTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for FilterWindow Constructor
        ///</summary>
        [TestMethod()]
        public void FilterWindowConstructorTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius);
            Assert.IsNotNull(target);
            Assert.AreEqual(target.ImageSize.X, width);
            Assert.AreEqual(target.ImageSize.Y, height);
            Assert.AreEqual(target.Radius, radius);
        }


        /// <summary>
        ///A test for GetRelative
        ///</summary>
        [TestMethod()]
        public void GetRelativeTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 10; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            Coordinate input = 10 * Coordinate.Right; // TODO: Initialize to an appropriate value
            Coordinate expected = 10 * Coordinate.Right; // TODO: Initialize to an appropriate value
            Coordinate actual;
            actual = target.GetRelative(input);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for GetRelative
        ///</summary>
        [TestMethod()]
        public void GetRelativeTest1()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            int x = -10; // TODO: Initialize to an appropriate value
            int y = -10; // TODO: Initialize to an appropriate value
            Coordinate expected = new Coordinate(0, 0); // TODO: Initialize to an appropriate value
            Coordinate actual;
            actual = target.GetRelative(x, y);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for Move
        ///</summary>
        [TestMethod()]
        public void MoveTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            Coordinate input = new Coordinate(100, 100); // TODO: Initialize to an appropriate value
            target.Move(input);
            Assert.AreEqual(input, target.Position);
        }

        /// <summary>
        ///A test for MoveToBottom
        ///</summary>
        [TestMethod()]
        public void MoveToBottomTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            target.MoveToBottom();
            Assert.AreEqual(target.Position.Y, height - 1);
        }

        /// <summary>
        ///A test for MoveToFirst
        ///</summary>
        [TestMethod()]
        public void MoveToFirstTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            target.MoveToFirst();
            Assert.AreEqual(target.Position.X, 0);
        }

        /// <summary>
        ///A test for MoveToLast
        ///</summary>
        [TestMethod()]
        public void MoveToLastTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            target.MoveToLast();
            Assert.AreEqual(target.Position.X, width - 1);
        }

        /// <summary>
        ///A test for MoveToTop
        ///</summary>
        [TestMethod()]
        public void MoveToTopTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            target.MoveToTop();
            Assert.AreEqual(target.Position.Y, 0);
        }

        /// <summary>
        ///A test for Bottom
        ///</summary>
        [TestMethod()]
        public void BottomTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            target.Position = new Coordinate(100, 100);
            int actual;
            actual = target.Bottom;
            Assert.AreEqual(target.Position.Y + radius, actual);
        }

        /// <summary>
        ///A test for BottomLeft
        ///</summary>
        [TestMethod()]
        public void BottomLeftTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            target.Position = new Coordinate(100, 100);
            Coordinate actual;
            actual = target.BottomLeft;
            Assert.AreEqual(target.Position + radius * (Coordinate.Down + Coordinate.Left), actual);
        }

        /// <summary>
        ///A test for BottomRight
        ///</summary>
        [TestMethod()]
        public void BottomRightTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            target.Position = new Coordinate(100, 100);
            Coordinate actual;
            actual = target.BottomRight;
            Assert.AreEqual(target.Position + radius * (Coordinate.Down + Coordinate.Right), actual);
        }

        /// <summary>
        ///A test for ImageSize
        ///</summary>
        [TestMethod()]
        public void ImageSizeTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            Coordinate expected = new Coordinate(width, height); // TODO: Initialize to an appropriate value
            Coordinate actual;
            target.ImageSize = expected;
            actual = target.ImageSize;
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for Left
        ///</summary>
        [TestMethod()]
        public void LeftTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            target.Position = new Coordinate(100, 100);
            int actual;
            actual = target.Left;
            Assert.AreEqual(actual, target.Position.X - radius);
        }

        /// <summary>
        ///A test for Position
        ///</summary>
        [TestMethod()]
        public void PositionTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            Coordinate expected = new Coordinate(); // TODO: Initialize to an appropriate value
            Coordinate actual;
            target.Position = expected;
            actual = target.Position;
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for Radius
        ///</summary>
        [TestMethod()]
        public void RadiusTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            int expected = 0; // TODO: Initialize to an appropriate value
            int actual;
            target.Radius = expected;
            actual = target.Radius;
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for Right
        ///</summary>
        [TestMethod()]
        public void RightTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            target.Position = new Coordinate(100, 100);
            int actual;
            actual = target.Right;
            Assert.AreEqual(target.Position.X + radius, actual);
        }

        /// <summary>
        ///A test for Top
        ///</summary>
        [TestMethod()]
        public void TopTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            target.Position = new Coordinate(100, 100);
            int actual;
            actual = target.Top;
            Assert.AreEqual(target.Position.Y - radius, actual);
        }

        /// <summary>
        ///A test for TopLeft
        ///</summary>
        [TestMethod()]
        public void TopLeftTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            target.Position = new Coordinate(100, 100);
            Coordinate actual;
            actual = target.TopLeft;
            Assert.AreEqual(target.Position + radius * (Coordinate.Left + Coordinate.Up), actual);
        }

        /// <summary>
        ///A test for TopRight
        ///</summary>
        [TestMethod()]
        public void TopRightTest()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            target.Position = new Coordinate(100, 100);
            Coordinate actual;
            actual = target.TopRight;
            Assert.AreEqual(target.Position + radius * (Coordinate.Right + Coordinate.Up), actual);
        }

        /// <summary>
        ///A test for Clamp
        ///</summary>
        [TestMethod()]
        public void ClampTest1()
        {
            int width = 800; // TODO: Initialize to an appropriate value
            int height = 600; // TODO: Initialize to an appropriate value
            int radius = 20; // TODO: Initialize to an appropriate value
            FilterWindow target = new FilterWindow(width, height, radius); // TODO: Initialize to an appropriate value
            int input = 20; // TODO: Initialize to an appropriate value
            int min = 0; // TODO: Initialize to an appropriate value
            int max = 20; // TODO: Initialize to an appropriate value
            int expected = 19; // TODO: Initialize to an appropriate value
            int actual;
            actual = target.Clamp(input, min, max);
            Assert.AreEqual(expected, actual);
        }
    }
}
