﻿using System;
using System.Security.Cryptography;
using ImageLab.Filter;


namespace Sandbox
{
    class Program
    {
        static int k = 1000, m = k * k;

        static void Main(string[] args)
        {


            Console.WriteLine("Done");
            Console.ReadKey();
        }



        private static void RNGProfiling()
        {
            var size_max = 10 * m;
            var run_max = 10;

            for (int size = 1000; size <= size_max; size *= 10)
            {
                Console.WriteLine("Size: " + size);

                var rng1 = new Random();
                var rng2 = new RNGCryptoServiceProvider();


                var buffer1 = new byte[size];
                var buffer2 = new byte[size];

                var pro1 = Profile.Start("Normal random: ");
                for (int run = 0; run < run_max; run++)
                    rng1.NextBytes(buffer1);
                pro1.Stop();

                var pro2 = Profile.Start("Cryptographic random: ");
                for (int run = 0; run < run_max; run++)
                    rng2.GetBytes(buffer2);
                pro2.Stop();
            }

            Console.ReadKey();
        }
        private static void MemoryCopyingProfiling()
        {
            var size = 3 * k;
            Console.WriteLine("Image size is " + size * size);

            var pr1 = Profile.Start("Memory reservation: ");
            var buffer = new byte[size * size * 4];
            var image = new int[size, size];
            pr1.Stop();

            var pr2 = Profile.Start("RNG: ");
            FilterCore.RNG.GetBytes(buffer);
            pr2.Stop();

            var pr3 = Profile.Start("Blockcopy: ");
            Buffer.BlockCopy(buffer, 0, image, 0, buffer.Length);
            pr3.Stop();

            Console.ReadKey();
        }


    }
}
